package org.cytoscape.filter.internal.filters.view;

/*
 * #%L
 * Cytoscape Filters Impl (filter-impl)
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2006 - 2013 The Cytoscape Consortium
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 2.1 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-2.1.html>.
 * #L%
 */


import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import java.util.Vector;

public class EditNameDialog extends JDialog implements ActionListener {
	
	/**
	 * Creates a new EditNetworkTitleDialog object.
	 *
	 * @param parent  DOCUMENT ME!
	 * @param modal  DOCUMENT ME!
	 * @param pName  DOCUMENT ME!
	 */
	public EditNameDialog(String pTitle, String pMsg, Vector pNameVect, int pWinX, int pWinY) {
		//super(parent, modal);
		initComponents();
	
		setModal(true);
		nameVect = pNameVect;
		String oldName = (String) pNameVect.elementAt(0); 
		tfName.setText(oldName);
		tfName.setSelectionStart(0);
		tfName.setSelectionEnd(oldName.length());

		setSize(new java.awt.Dimension(pWinX, pWinY));
		setTitle(pTitle);
		jLabel1.setText(pMsg);
		
		btnOK.addActionListener(this);
		btnCancel.addActionListener(this);

		tfName.addActionListener(this);
	}

	private Vector<String> nameVect;
	
	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */

	// <editor-fold defaultstate="collapsed" desc=" Generated Code ">
	private void initComponents() {
		GridBagConstraints gridBagConstraints;

		jLabel1 = new JLabel();
		tfName = new JTextField();
		jPanel1 = new JPanel();
		btnOK = new JButton();
		btnCancel = new JButton();

		getContentPane().setLayout(new GridBagLayout());

		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		//setTitle("Edit Network Title");
		//jLabel1.setText("Please enter new network title:");
		gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(15, 10, 0, 0);
		getContentPane().add(jLabel1, gridBagConstraints);

		gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridy = 1;
		gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new Insets(10, 10, 10, 10);
		getContentPane().add(tfName, gridBagConstraints);

		btnOK.setText("OK");
		btnOK.setPreferredSize(new Dimension(65, 23));
		//btnCancel.setPreferredSize(new Dimension(65, 23));

		jPanel1.add(btnOK);

		btnCancel.setText("Cancel");
		jPanel1.add(btnCancel);

		gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridy = 2;
		gridBagConstraints.insets = new Insets(10, 0, 10, 0);
		getContentPane().add(jPanel1, gridBagConstraints);

		pack();
	} // </editor-fold>

	/**
	 *  DOCUMENT ME!
	 *
	 * @param e DOCUMENT ME!
	 */
	public void actionPerformed(ActionEvent e) {
		Object _actionObject = e.getSource();

		// handle Button events
		if (_actionObject instanceof JButton) {
			JButton _btn = (JButton) _actionObject;

			if (_btn == btnOK) {
				nameVect.set(0, tfName.getText().trim());
			} 
			else if (_btn == btnCancel) {
				nameVect.set(0, null);
			}
		}
		else if (_actionObject instanceof JTextField) {
			JTextField _tf = (JTextField) _actionObject;
			if (_tf == tfName) {
				nameVect.set(0, tfName.getText().trim());
			}
		}
		this.dispose();
	}


	// Variables declaration - do not modify
	private JButton btnCancel;
	private JButton btnOK;
	private JLabel jLabel1;
	private JPanel jPanel1;
	private JTextField tfName;

	// End of variables declaration
}
