package org.cytoscape.view.vizmap.internal.mappings;

/*
 * #%L
 * Cytoscape VizMap Impl (vizmap-impl)
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2006 - 2013 The Cytoscape Consortium
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 2.1 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-2.1.html>.
 * #L%
 */

import java.awt.Paint;

import org.cytoscape.view.vizmap.internal.util.ColorUtil;
import org.cytoscape.view.vizmap.mappings.ValueTranslator;

public class ColorTranslator implements ValueTranslator<String, Paint>{

	@Override
	public Paint translate(String inputValue) {
		if(inputValue != null)
			return ColorUtil.parseColorText(inputValue);
		else
			return null;
	}

	@Override
	public Class<Paint> getTranslatedValueType() {
		return Paint.class;
	}

}
